ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c         Zeta From Mathematica
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
          
      function Zeta(ind)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      integer:: ind
      real(dp):: Zeta
          
          Zeta=0._dp
          
          if(ind.eq.2) then
          Zeta=1.6449340668482262_dp
          elseif (ind.eq.3) then
          Zeta=1.2020569031595942_dp
          elseif (ind.eq.4) then
          Zeta=1.0823232337111381_dp
          elseif (ind.eq.5) then
          Zeta=1.03692775514337_dp
          else 
          write(*,*) 'Index Zeta wrong'
          endif
          
      return
      end          

c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c             HPLS  Peso 1
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


      function Ho(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Ho

      Ho=log(x)
      return
      end

      function H1h(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1h
c     Aqui se reemplaza por H1h para que no se confunda con H1      
      H1h=-log(1.0_dp-x)
      return
      end
      
      function Hm1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm1

      Hm1=log(1.0_dp+x)
      return
      end
      
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c             HPLS  Peso 2
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      

      function Hoo(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hoo

      Hoo=0.5_dp*log(x)**2
      return
      end
      
      function H10(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,H10
      external myli2

      H10=-(Log(1.0_dp - x)*Log(x)) - myli2(x)
      return
      end
      
      function Hm10(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,Hm10
      external myli2

      Hm10=Log(x)*Log(1.0_dp + x) + myli2(-x)
      return
      end
      
      function H11(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H11

      H11=Log(1.0_dp - x)**2/2._dp
      return
      end
      
      function H2h(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,H2h
      external myli2
c     Aqui se reemplaza por H1h para que no se confunda con H1   
      H2h=myli2(x)
      return
      end
      
      function Hm2(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,Hm2
      external myli2

      Hm2=-myli2(-x)
      return
      end
      
      
      function Hm1m1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm1m1

      Hm1m1=Log(1.0_dp + x)**2/2.0_dp
      return
      end
      
      function H1m1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,H1m1
      external myli2

      H1m1=-Pi**2/12._dp + Log(2._dp)**2/2._dp - 
     & Log(2._dp)*Log(1._dp - x) + myli2((1._dp - x)/2._dp)
      return
      end

      function Hm11(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,Hm11
      external myli2

      Hm11=-Pi**2/12._dp + Log(2._dp)**2/2._dp 
     & - Log(2._dp)*Log(1._dp + x) + myli2((1._dp + x)/2._dp)
      return
      end
          
      
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c             HPLS  Peso 3
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      
      
      function Hooo(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hooo

      Hooo=Log(x)**3/6._dp
      return
      end
      
      function H3h(x) !w3B2 
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: H3h
c     Cambio de nombre para no confundir con H3
      real(dp):: x,y,Zeta,Hm1,Hm10,Hm100,Hm1m10,Hm1m11,H1h,H2h,Ho,Hm11,Hm110,Hm12,Hm111,H21
      external Zeta,Hm1,Hm10,Hm100,Hm1m10,Hm1m11,H1h,H2h,Ho,Hm11,Hm110,Hm12,Hm111,H21
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3

      H3h = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      H3h = HB3(0, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)

      H3h= -(Pi**2*H1h(y))/6._dp - H21(y) + H1h(y)*H2h(y) - 
     -  (Pi**2*Hm1(y))/6._dp + (H1h(y)**2*Hm1(y))/2._dp + 
     -  (H1h(y)*Hm1(y)**2)/2._dp + Hm1(y)**3/6._dp - H1h(y)*Hm10(y) - 
     -  H1h(y)*Hm11(y) + Hm111(y) + Hm12(y) - Hm1m10(y) - 
     -  Hm1m11(y) - (H1h(y)**2*Ho(y))/2._dp - (H1h(y)**2*Log(2._dp))/2._dp - 
     -  H1h(y)*Hm1(y)*Log(2._dp) - (Hm1(y)**2*Log(2._dp))/2._dp + Zeta(3)
      else
      write(*,*)' x out of range H21 x = ',x
      endif     
     
      return
      end
      
      function Hm3(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli3,Hm3
      external myli3
      
      Hm3=-myli3(-x)
      return
      end
      
        
      function H20(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H20,myli2,myli3
      external myli3
      external myli2

      H20=Log(x)*myli2(x) - 2.0_dp*myli3(x)
      return
      end

      
      function Hm20(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,Hm20
      external myli3
      external myli2

      Hm20=-(Log(x)*myli2(-x)) + 2._dp*myli3(-x)
      return
      end


      
      function H21(x) !w3B1
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: H21
      real(dp):: x,y,Zeta,H3h,Hm1,Hm10,Hm100,Hm1m10,Hm1m11,H1h,H2h,Ho,Hm11,Hm110
      external Zeta,H3h,Hm1,Hm10,Hm100,Hm1m10,Hm1m11,H1h,H2h,Ho,Hm11,Hm110
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3

      H21 = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      H21 = HB3(0, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      H21 = -H3h(y) - H2h(y)*Hm1(y) - (H1h(y)*Hm1(y)**2)/2._dp - 
     -  Hm1(y)**3/6._dp + Hm1(y)*Hm10(y) - Hm100(y) + 
     -  Hm1(y)*Hm11(y) - Hm110(y) - Hm1m10(y) - Hm1m11(y) + 
     -  H2h(y)*Ho(y) + H1h(y)*Hm1(y)*Ho(y) - 
     -  (H1h(y)*Ho(y)**2)/2._dp + H2h(y)*Log(2._dp) + 
     -  H1h(y)*Hm1(y)*Log(2._dp) + (Hm1(y)**2*Log(2._dp))/2._dp - 
     -  Hm10(y)*Log(2._dp) - Hm11(y)*Log(2._dp) - H1h(y)*Ho(y)*Log(2._dp) - 
     -  (H1h(y)*Log(2._dp)**2)/2._dp - (Hm1(y)*Log(2._dp)**2)/2._dp + Zeta(3)
      
      else
      write(*,*)' x out of range H21 x = ',x
      endif
      return
      end


      
      function H2m1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H2m1,myli2,myli3,Zeta
      external Zeta
      external myli3
      external myli2

      H2m1= (Pi**2/12._dp - Log(2._dp)**2/2._dp)*Log(1._dp + x) + 
     &  (Log(2._dp)*Log(1._dp + x)**2)/2._dp + Log(1._dp + x)*myli2(x)
     &   - myli3(x) - 
     &  myli3(x/(1._dp + x)) + myli3((2._dp*x)/(1._dp + x))
     &  - myli3((1._dp + x)/2._dp) + 
     &  (-2._dp*Pi**2*Log(2._dp) + 
     &  4._dp*Log(2._dp)**3 + 21._dp*Zeta(3))/24._dp
      return
      end

      
      function Hm21(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,Zeta,Hm21
      external Zeta
      external myli3
      external myli2

      Hm21=(Pi**2/12._dp - Log(2._dp)**2/2._dp)*Log(1._dp - x) + 
     &  (Log(2._dp)*Log(1._dp - x)**2)/2._dp - 
     &  Log(1._dp - x)**3/6._dp - 
     &  (Log(1._dp - x)**2*Log(x))/2._dp - 
     &   Log(1._dp - x)*myli2(1._dp - x) + 
     &  Log(1._dp - x)*myli2(-x) - Log(1._dp - x)*myli2(x) - 
     &  myli3((1._dp - x)/2._dp) + myli3(1._dp - x)
     &  - myli3(-x) + myli3(x) + 
     &  myli3((-2._dp*x)/(1._dp - x)) - Zeta(3) + 
     &  (-2*Pi**2*Log(2._dp) + 4._dp*Log(2._dp)**3 +
     &   21._dp*Zeta(3))/24._dp
      return
      end

      
      function Hm2m1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,Zeta,Hm2m1
      external Zeta
      external myli3
      external myli2

      Hm2m1= -(Pi**2*Log(1._dp + x))/6._dp - 
     & (Log(x)*Log(1._dp + x)**2)/2._dp + 
     &  Log(1._dp + x)**3/6._dp - Log(1 + x)*myli2(-x)
     & - myli3(1._dp/(1._dp + x)) + 
     &  Zeta(3)
      return
      end

      
      
      function H100(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H100,myli2,myli3
      external myli3
      external myli2

      H100=-(Log(1._dp - x)*Log(x)**2)/2._dp
     & - Log(x)*myli2(x) + myli3(x)
      return
      end
      
            
      function Hm100(x) !w3B6
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,y,Hm100,Zeta,Hm1,Hm11,Hm111,Hm1m11
      external Zeta,Hm1,Hm11,Hm111,Hm1m11
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3

      Hm100 = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      Hm100 = HB3(-1, 0, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      Hm100=-Hm1(y)**3/6._dp - Hm1(y)*Hm11(y) - Hm111(y) + Hm1m11(y) + 
     -  (3._dp*Zeta(3))/4._dp
      else
      write(*,*)' x out of range Hm100 x = ',x
      endif
      
      return
      end
      
            
      function H12(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H12,myli2,myli3,Zeta
      external myli3,Zeta
      external myli2

      H12=     -(Log(1._dp - x)*myli2(x)) - 
     &  2*((Log(1._dp - x)**2*Log(x))/2._dp + Log(1._dp - x)
     &  *myli2(1._dp - x) - 
     &     myli3(1._dp - x) + Zeta(3))
      return
      end

      
      function H1m2(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1m2,H2h,Hm1,Hm12,H1h,Hm2
      external H2h,Hm1,Hm12,H1h,Hm2

      H1m2=-(H2h(x)*Hm1(x)) + Hm12(x) + H1h(x)*Hm2(x)
      return
      end

      
      
      function H110(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H110,myli2,myli3,Zeta
      external Zeta
      external myli3
      external myli2

      H110= Log(1._dp - x)**2*Log(x) + Log(1._dp - x)
     & *myli2(1._dp - x) + 
     &  Log(1._dp - x)*myli2(x) - myli3(1._dp - x) + Zeta(3)
      return
      end

      
      function H1m10(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1m10,Zeta,H1h,Hm10,Hm110,Hm12
      external Zeta,H1h,Hm10,Hm110,Hm12

      H1m10= H1h(x)*Hm10(x) - Hm110(x) - Hm12(x)
      return
      end
      
      
           
      function H111(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H111

      H111=-Log(1._dp - x)**3/6._dp
      return
      end

 
            
      function H11m1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H11m1,myli2,myli3,Zeta
      external Zeta
      external myli3
      external myli2


      H11m1=log(1._dp - x)*(myli2((1._dp - x)/2._dp) + 
     &  myli2((1._dp + x)/2._dp)) + 
     &  (4._dp*log(2._dp)**3 - Pi**2*log(4._dp) - 
     &     2._dp*log(1._dp - x)*(Pi**2 - 6._dp*log(2._dp)**2 
     &   + log(64._dp)*log(1._dp - x) - 
     &        12._dp*log((1._dp - x)/2._dp)*log(1._dp + x)) -
     &    24._dp*myli3((1._dp - x)/2._dp) + 
     &     21._dp*Zeta(3))/24._dp
      return
      end

  
c todo con -1    
      
            
      function Hm12(x) !w3B5
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,y,Hm12,Zeta,Hm1,Hm11,Hm110,Hm1m10,Hm1m11
      external Zeta,Hm1,Hm11,Hm110,Hm1m10,Hm1m11
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3

      Hm12 = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      Hm12 = HB3(-1, 0, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      Hm12= -(Pi**2*Hm1(y))/6._dp + Hm1(y)**3/6._dp + Hm1(y)*Hm11(y) - 
     -  Hm110(y) - Hm1m10(y) - 2._dp*Hm1m11(y) + (Pi**2*Log(2._dp))/6._dp - 
     -  (Hm1(y)**2*Log(2._dp))/2._dp - Hm11(y)*Log(2._dp) - (5._dp*Zeta(3))/8._dp
     
      else
      write(*,*)' x out of range Hm12.  x = ',x
      endif
      
      return
      end

      
      
      function Hm1m2(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm1m2,myli2,myli3,Zeta
      external Zeta
      external myli3
      external myli2

      Hm1m2 =(Pi**2*log(1._dp + x))/3._dp + log(x)*log(1._dp + x)**2 - 
     &  log(1._dp + x)**3/3._dp + log(1._dp + x)*myli2(-x) 
     &  + 2._dp*myli3(1._dp/(1._dp + x)) - 
     &  2._dp*Zeta(3)
      return
      end

      
      function Hm110(x) !w3B4
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,y,Hm110,Zeta,Hm1,Hm10,Hm12,Hm1m10,Hm1m11     
      external Zeta,Hm1,Hm10,Hm12,Hm1m10,Hm1m11  
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3
      Hm110 = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      Hm110 = HB3(-1, 1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      Hm110=(Pi**2*Hm1(y))/6._dp + Hm1(y)**3/6._dp - Hm1(y)*Hm10(y) - 
     -  Hm12(y) + 2._dp*Hm1m10(y) + Hm1m11(y) + (Pi**2*Log(2._dp))/12._dp - 
     -  Zeta(3)
     
     
      else
      write(*,*)' x out of range Hm110.  x = ',x
      endif
      return
      end

      
      function Hm1m10(x) !w3B8
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,y,Hm1m10,Zeta,Hm1,Hm1m11
      external Zeta
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3
      Hm1m10 = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      Hm1m10 = HB3(-1, -1, 0,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
      
      Hm1m10=(Pi**2*Hm1(y))/12._dp - Hm1(y)**3/6._dp - Hm1m11(y) - 
     -  (Pi**2*Log(2._dp))/12._dp + Zeta(3)/8._dp
      else
      write(*,*)' x out of range Hm111.  x = ',x
      endif      
      
      return
      end
      
      
           
      function Hm111(x) !w3B3
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,y,Hm111,Zeta,Hm1,Hm10,Hm100, Hm1m10
      external Zeta,Hm1,Hm10,Hm100, Hm1m10
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3
      Hm111 = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      Hm111 = HB3(-1, 1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)

      Hm111= -Hm1(y)**3/6._dp + Hm1(y)*Hm10(y) - Hm100(y) - Hm1m10(y) - 
     -  (Pi**2*Log(2._dp))/12._dp + (Hm1(y)**2*Log(2._dp))/2._dp - 
     -  Hm10(y)*Log(2._dp) - (Hm1(y)*Log(2._dp)**2)/2._dp + Log(2._dp)**3/6._dp + 
     -  (7._dp*Zeta(3))/8._dp
      else
      write(*,*)' x out of range Hm111.  x = ',x
      endif
      return
      end


       
            
      function Hm11m1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm11m1,myli2,myli3,Zeta
      external Zeta
      external myli3
      external myli2


      Hm11m1= -(Pi**2*log(2._dp))/6._dp + log(2._dp)**3/3._dp + 
     &  log((1._dp - x)/2._dp)*log(1._dp + x)**2 + 
     &  log(1._dp + x)*(-Pi**2/12._dp + log(2._dp)**2/2._dp - 
     &   log(2._dp)*log(1._dp - x) + 
     &     myli2((1._dp - x)/2._dp)) + 
     &  2._dp*log(1._dp + x)*myli2((1._dp + x)/2._dp) - 
     &  2._dp*myli3((1._dp + x)/2._dp) + (7._dp*Zeta(3))/4._dp
      return
      end      
      
      
      function Hm1m1m1(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm1m1m1

      Hm1m1m1=Log(1._dp + x)**3/6._dp
      return
      end     

      
      function Hm1m11(x) !w3B7
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,y,Hm1m11,Zeta,Hm1,Hm1m10
      external Zeta,Hm1,Hm1m10
      REAL*8   HB3
      INTEGER  IW 
      COMMON/WEIGHT/ IW
*  
      EXTERNAL HB3
      Hm1m11 = zip
      if(0._dp<x.and.x<(sqrt(2._dp)-1._dp))then
      Hm1m11 = HB3(-1, -1, 1,x)
      elseif((sqrt(2._dp)-1._dp)<x.and.x<1._dp)then
      y = (1._dp - x)/(1._dp + x)
c      
      Hm1m11= -(Pi**2*Hm1(y))/12._dp + Hm1(y)**3/6._dp - Hm1m10(y) - 
     -  (Hm1(y)**2*Log(2._dp))/2._dp + (Hm1(y)*Log(2._dp)**2)/2._dp - 
     -  Log(2._dp)**3/6._dp + Zeta(3)/8._dp
      else
      write(*,*)' x out of range Hm111.  x = ',x
      endif
      return
      end           
      
C The following HPLS are not used by my convolutions
C The following HPLS are used by HBL 03.08.2020
      function H1m11(x) !c26
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1m11,myli2,myli3,Zeta
      external Zeta
      external myli3
      external myli2
      
      H1m11=(-4._dp*Log(2._dp)**3 + Pi**2*Log(4._dp) + 
     &    Log(1._dp - x)*(Pi**2 - 6._dp*Log(2._dp)**2 
     &    - 12._dp*Log(1._dp - x)*Log((1._dp + x)/2._dp) + 
     &       12._dp*Log(2._dp)*Log(1._dp + x)) - 
     &    12._dp*Log(1._dp - x)*(2._dp*myli2((1._dp - x)/2._dp)
     &    + myli2((1._dp + x)/2._dp)) + 
     &    24._dp*myli3((1._dp - x)/2._dp) - 21._dp*Zeta(3))/12._dp
     
      return
      end     
      
      function H1m1m1(x) !c27
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1m1m1,myli2,myli3,Zeta
      external Zeta
      external myli3
      external myli2
      
      H1m1m1= -(Log((1._dp - x)/2._dp)*Log(1._dp + x)**2)/2._dp 
     & - Log(1._dp + x)*myli2((1._dp + x)/2._dp) + 
     &  myli3((1._dp + x)/2._dp) + (2._dp*Pi**2*Log(2._dp) 
     & - 4._dp*Log(2._dp)**3 - 21._dp*Zeta(3))/24._dp
      return
      end                       
            
      
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c             HPLS  Peso 4
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      
         
      function Hoooo(x) !c1
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hoooo

      Hoooo=Log(x)**4/24._dp
      return
      end
      
      
      
      function H4(x) !c2
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli4,H4
      external myli4

      H4=myli4(x)
      return
      end      
      
      
      
      function Hm1m100(x) !c3
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm1m100,myli2,myli3,myli4,Zeta
      external Zeta
      external myli3
      external myli2,myli4

      Hm1m100=      Pi**4/90. - (Pi**2*log(x)*log(1 + x))/6. + 
     &  (Pi**2*log(1 + x)**2)/12. - (log(x)**2*log(1 + x)**2)/4. + 
     &  (log(x)*log(1 + x)**3)/3. - log(1 + x)**4/12. - 
     &  log(x)*myli3(1/(1 + x)) - myli4(-x) - myli4(1/(1 + x)) - 
     &  myli4(x/(1 + x)) + log(x)*Zeta(3) - log(1 + x)*Zeta(3)
      return
      end      
         
       
      function H2m2(y) !c4
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,H2m2,H2m2n
      real(dp):: HBm1010,H3h,Hm1,H2h,Hm2,Hm12,Ho,Hm120
      external HBm1010,H3h,Hm1,H2h,Hm2,Hm12,Ho,Hm120
      
c      write(*,*)' inside H2m2(z) '
c      H2m2 = -HBm1010(y) - 2._dp*H3h(y)*Hm1(y) + H2h(y)*Hm2(y)
c     &  + Hm12(y)*Ho(y)
      H2m2 = -2._dp*H3h(y)*Hm1(y) - Hm120(y) + H2h(y)*Hm2(y) + Hm12(y)*Ho(y)
     
c      write(*,*)' H2m2 : ',H2m2
c      write(*,*)' H2m2n : ',H2m2n
      
c~       ! Funcion que viene del fitted
c~       ! Solo valida para 0<x<1
c~       ! Leandro 05.10.2017
c~ c      H2m2=hpl4(0,1,0,-1,x)

c~        H2m2= 0.000045733685403291385_dp - 1.6973863079363938_dp*x + 
c~      -  2.253400058789283_dp*x**2 - 1.4364783147339935_dp*x**3 + 
c~      -  0.5591294016130762_dp*x**4 - 0.2472364513864441_dp*x**5 - 
c~      -  (1.7020281519914822_dp - 3.2907677523576093_dp*x 
c~      &  + 2.5795717234968945_dp*x**2 - 
c~      -     1.3134416529563253_dp*x**3 + 0.3635648385515103_dp*x**4 - 
c~      -     0.040955308729751456_dp*x**5)*log(1._dp - x) - 
c~      -  (0.00002780276203162_dp + 0.0029409819233852013_dp*x + 
c~      -     0.04692983706455525_dp*x**2 + 0.18026429991986812_dp*x**3 + 
c~      -     0.17131753077399187_dp*x**4 + 
c~      &  0.027019807419234054_dp*x**5)*myli2(1.0_dp - x)

c~         ! El menos se debe a que el fiteo es para G[{0,1,0,-1},z]
c~         ! La diferencia entre HPLS y GPLS es HPLS = (-1)^n GPLS
c~         ! donde n es la cantidad de 1 que tiene el peso {w}
c~         H2m2= -H2m2

      return
      end           
   
      function Hm1m12(x) !c5
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,Hm1m12,Zeta,HBm1m101
      external Zeta,HBm1m101    

      Hm1m12= HBm1m101(x)
      return
      end      
            
      
      function Hm120(x) !c6
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,Hm120,Zeta,HBm1010
      external Zeta,HBm1010

      Hm120=HBm1010(x)
      
      return
      end           

      
      function Hm200(x) !c7
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm200,myli2,myli3,myli4,Zeta
      external Zeta
      external myli3
      external myli2,myli4

       Hm200=-(log(x)**2*myli2(-x))/2. 
     & + 2._dp*log(x)*myli3(-x) - 3._dp*myli4(-x)
      return
      end     
      
      
      function H210(x) !c8
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H210,myli2,myli3,Zeta,myli4    
      external Zeta
      external myli3
      external myli2,myli4

      H210=(Pi**2*log(1 - x)*log(x))/6. - 
     &  (log(1 - x)**2*log(x)**2)/2. - 
     &  log(1 - x)*log(x)*myli2(x) - myli2(x)**2/2. - 
     &  log(x)*myli3(1 - x) + log(x)*Zeta(3)
     
      return
      end           

      
      
      function H211(x) !c9
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,Zeta,myli4,H211     
      external Zeta
      external myli3
      external myli2,myli4

      H211=Pi**4/90. - (log(1 - x)**3*log(x))/6. - 
     &  (log(1 - x)**2*myli2(1 - x))/2. + log(1 - x)*myli3(1 - x) - 
     &  myli4(1 - x)
      return
      end           
       
   
      function H30(x) !c10
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H30,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4

      H30=log(x)*myli3(x) - 3*myli4(x)
      return
      end           
      
      
      function Hm30(x) !c11
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,Zeta,myli4,Hm30
      external Zeta
      external myli3
      external myli2,myli4

      Hm30=-(log(x)*myli3(-x)) + 3*myli4(-x)
      return
      end                       


      
      function H200(x) !c12
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,myli4,H200,Zeta
      external Zeta
      external myli2
      external myli3,myli4

      H200=(log(x)**2*myli2(x))/2. - 2*log(x)*myli3(x) + 3*myli4(x)
      return
      end                       

      
      function H31(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli3,myli4,Zeta,H31
      external Zeta
      external myli3
      external myli4

      H31=Pi**4/90. + (Pi**2*log(1 - x)**2)/12. 
     & + log(1 - x)**4/24. - 
     &  (log(1 - x)**3*log(x))/6. - log(1 - x)*myli3(x) - 
     &  myli4(1 - x) + myli4(x) + myli4(-(x/(1 - x))) + 
     &  log(1 - x)*Zeta(3)
      return
      end                       

      
      function Hm22(y) !c14
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: Hm22,y,Zeta,HBm1001,HBm1010,Hm12,Ho
      external Zeta,HBm1001,HBm1010,Hm12,Ho

      Hm22= -2._dp*HBm1001(y) - HBm1010(y) + Hm12(y)*Ho(y)
      return
      end      

      function H1m20(y) !c15
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: H1m20,y,Zeta,HBm1001,HBm1010,H10,Hm10,H1h,Hm100
      external Zeta,HBm1001,HBm1010,H10,Hm10,H1h,Hm100

      H1m20= 2._dp*HBm1001(y) + HBm1010(y) + H10(y)*Hm10(y) - 2._dp*H1h(y)*Hm100(y)
      return
      end     
      
      function H120(x) !c16
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H120,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4 

       H120=Pi**4/45. + (Pi**2*log(1 - x)**2)/6. 
     &  + log(1 - x)**4/12. - 
     &  (Pi**2*log(1 - x)*log(x))/3. - 
     &  (log(1 - x)**3*log(x))/3. + log(1 - x)**2*log(x)**2 + 
     &  log(1 - x)*log(x)*myli2(x) + myli2(x)**2/2. + 
     &  2*log(x)*myli3(1 - x) - 2*myli4(1 - x) + 2*myli4(x) + 
     &  2*myli4(-(x/(1 - x))) + 2*log(1 - x)*Zeta(3) - 
     &  2*log(x)*Zeta(3)
      return
      end
      
      function H1000(x)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1000,myli2,myli3,Zeta,myli4 
      external Zeta
      external myli3
      external myli2,myli4 

        H1000= -(log(1 - x)*log(x)**3)/6. - 
     &  (log(x)**2*myli2(x))/2. + 
     &  log(x)*myli3(x) - myli4(x)
      return
      end                        
       

      function Hm1000(x) !c18
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm1000,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4 

      Hm1000=(log(x)**3*log(1 + x))/6. + 
     & (log(x)**2*myli2(-x))/2. - 
     &  log(x)*myli3(-x) + myli4(-x)
      return
      end            
       
          
      function H1100(x) !c19
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1100,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4 

      H1100= -Pi**4/90. - (Pi**2*log(1 - x)**2)/12. - 
     &  log(1 - x)**4/24. + (Pi**2*log(1 - x)*log(x))/6. + 
     &  (log(1 - x)**3*log(x))/6. - 
     &  (log(1 - x)**2*log(x)**2)/4. - log(x)*myli3(1 - x) + 
     &  myli4(1 - x) - myli4(x) - myli4(-(x/(1 - x))) - 
     &  log(1 - x)*Zeta(3) + log(x)*Zeta(3)
      return
      end
          
      
      function Hm1m20(x) !c20
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,Hm1m20,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4 

      Hm1m20=-Pi**4/45. + (Pi**2*log(x)*log(1 + x))/3. - 
     &  (Pi**2*log(1 + x)**2)/6. + log(x)**2*log(1 + x)**2 - 
     &  (2*log(x)*log(1 + x)**3)/3. + log(1 + x)**4/6. + 
     &  log(x)*log(1 + x)*myli2(-x) + myli2(-x)**2/2. + 
     &  2*log(x)*myli3(1/(1 + x)) + 2*myli4(-x) + 
     &  2*myli4(1/(1 + x)) + 2*myli4(x/(1 + x)) - 2*log(x)*Zeta(3) + 
     &  2*log(1 + x)*Zeta(3)
      return
      end     
      
      
      function H13(x) !c21
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H13,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4 

      H13=-myli2(x)**2/2. - log(1 - x)*myli3(x)
      return
      end                
      
      
      function Hm13(x) !c22
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,Hm13,Zeta,HBm1001
      external Zeta,HBm1001

      Hm13=HBm1001(x)
      return
      end                
      
      
      function H22(x) !c23
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,Zeta,myli4,H22
      external Zeta
      external myli3
      external myli2,myli4  

      H22=-Pi**4/45. - (Pi**2*log(1 - x)**2)/6.
     & - log(1 - x)**4/12. + 
     &  (log(1 - x)**3*log(x))/3. + myli2(x)**2/2. + 
     &  2*log(1 - x)*myli3(x) + 2*myli4(1 - x) - 2*myli4(x) - 
     &  2*myli4(-(x/(1 - x))) - 2*log(1 - x)*Zeta(3)
      return
      end                
      
      function Hm2m10(x) !c24
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,myli2,myli3,Zeta,myli4,Hm2m10
      external Zeta
      external myli3
      external myli2,myli4

      Hm2m10=  -(Pi**2*log(x)*log(1 + x))/6. - 
     &  (log(x)**2*log(1 + x)**2)/2. + 
     &  (log(x)*log(1 + x)**3)/6. - log(x)*log(1 + x)*myli2(-x) - 
     &  myli2(-x)**2/2. - log(x)*myli3(1/(1 + x)) + log(x)*Zeta(3)
      return
      end      
      

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c H1111[x_] := N[HPL[{1, 1, 1, 1}, x]](*checked*)
c
c H112[x_] := N[HPL[{1, 1, 0, 1}, x]](*checked*)
c
c H121[x_] := N[HPL[{1, 0, 1, 1}, x]](*checked*)
c
c H1110[x_] := N[HPL[{1, 1, 1, 0}, x]](*checked*)
c
c Hm1m1m10[x_] := N[HPL[{-1, -1, -1, 0}, x]](*checked*)
c
c Hm121[x_] := N[HPL[{-1, 0, 1, 1}, x]](*checked*)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 
      

      function H1111(x) !c25
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1111

      H1111=log(1.0_dp - x)**4/24._dp
      return
      end      
      
      function H112(x) !c26
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H112,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4

      H112=     (log(1 - x)**2*myli2(x))/2. + 
     &  3*(Pi**4/90. - (log(1 - x)**3*log(x))/6. - 
     &     (log(1 - x)**2*myli2(1 - x))/2. + 
     &     log(1 - x)*myli3(1 - x) - myli4(1 - x)) + 
     &  2*log(1 - x)*((log(1 - x)**2*log(x))/2. + 
     &     log(1 - x)*myli2(1 - x) - myli3(1 - x) + Zeta(3))
      return
      end      
      
      function H121(x) !c27
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H121,myli2,myli3,Zeta,myli4 
      external Zeta
      external myli3
      external myli2,myli4

      H121=-3*(Pi**4/90. - (log(1 - x)**3*log(x))/6. - 
     &     (log(1 - x)**2*myli2(1 - x))/2. + 
     &     log(1 - x)*myli3(1 - x) - myli4(1 - x)) - 
     &  log(1 - x)*((log(1 - x)**2*log(x))/2. + 
     &     log(1 - x)*myli2(1 - x) - myli3(1 - x) + Zeta(3))
      return
      end      
      
      
      function H1110(x) !c28
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'nf.f'
      real(dp):: x,H1110,myli2,myli3,Zeta,myli4
      external Zeta
      external myli3
      external myli2,myli4

      H1110= -Pi**4/90. - (Pi**2*log(1 - x)**2)/12. + myli4(1 - x) - 
     &  log(1 - x)*Zeta(3)
      return
      end      
      
      function Hm1m1m10(x) !c29
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,Hm1m1m10,Zeta,HBm1m1m10
      external Zeta,HBm1m1m10
 

      Hm1m1m10= HBm1m1m10(x)
      return
      end      
      
      
      function Hm121(x) !c30
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: x,Hm121,Zeta,HBm1011
      external Zeta,HBm1011
c
      Hm121= HBm1011(x)
      
      return
      end      
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     New HPL weight 4 for the P3gg
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function H3m1(y) !c31
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,H3m1,Zeta,HBm1100,H3h,Hm1,Hm110,Ho,Hm11,Hoo
      external HBm1100,H3h,Hm1,Hm110,Ho,Hm11,Hoo
c
      H3m1 = -HBm1100(y) + H3h(y)*Hm1(y) + Hm110(y)*Ho(y) - Hm11(y)*Hoo(y)
      
      return
      end 

      function Hm4(y) !c32
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,Hm4,Zeta,Hm1000,Hm100,Ho,Hm10,Hoo,Hm2
      external Hm1000,Hm100,Ho,Hm10,Hoo,Hm2
c
      Hm4 = -Hm1000(y) + Hm100(y)*Ho(y) - (2*Hm10(y)*Hoo(y))/3. + (Hm2(y)*Hoo(y))/3.
      
      return
      end 

      function Hm3m1(y) !c31
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,Hm3m1,Zeta,Hm10,Hm1,Hm100,Hm1m100,Hm2,Hm1m10,Ho
      external HBm1100,Hm10,Hm1,Hm100,Hm1m100,Hm2,Hm1m10,Ho
c
      Hm3m1 = (-3*Hm10(y)**2)/4._dp + Hm1(y)*Hm100(y) - Hm1m100(y) - (Hm10(y)*Hm2(y))/2._dp + 
     -  Hm2(y)**2/4._dp + Hm1m10(y)*Ho(y)
      
      return
      end 
      
      function hm31(y)
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,hm31,HBm1100,Hm120,Hm13,Hm110,Ho,Hm12,Hm11,Hoo
      external HBm1100,Hm120,Hm13,Hm110,Ho,Hm12,Hm11,Hoo
      
      hm31 = HBm1100(y) + Hm120(y) + Hm13(y) - Hm110(y)*Ho(y) - Hm12(y)*Ho(y) + Hm11(y)*Hoo(y)
      
      return
      end
      
      function hm2m2(y)
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,hm2m2,Hm10,Hm1,Hm100,Hm1m100,Hm2,Hm1m10,Ho
      external Hm10,Hm1,Hm100,Hm1m100,Hm2,Hm1m10,Ho

      hm2m2 = (3*Hm10(y)**2)/2. - 2*Hm1(y)*Hm100(y) + 2*Hm1m100(y) + Hm10(y)*Hm2(y) - 
     -  2*Hm1m10(y)*Ho(y)
      
      return
      end

      function hm1m3(y)
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,hm1m3,Hm10,Hm1,Hm100
      external Hm10,Hm1,Hm100

      hm1m3 = -Hm10(y)**2/2. + Hm1(y)*Hm100(y)
      
      return
      end

      function hm2m1m1(y)
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,hm2m1m1,Hm10,Hm1m1,Hm1,Hm1m10,Hm1m1m10,Hm2
      external Hm10,Hm1m1,Hm1,Hm1m10,Hm1m1m10,Hm2

      hm2m1m1 = (-2*Hm10(y)*Hm1m1(y))/3. + Hm1(y)*Hm1m10(y) - Hm1m1m10(y) + (Hm1m1(y)*Hm2(y))/3.
      
      return
      end

      function hm1m2m1(y)
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,hm1m2m1,Hm10,Hm1m1,Hm1,Hm1m10,Hm1m1m10
      external Hm10,Hm1m1,Hm1,Hm1m10,Hm1m1m10

      hm1m2m1 = Hm10(y)*Hm1m1(y) - 2*Hm1(y)*Hm1m10(y) + 3*Hm1m1m10(y)
      
      return
      end

      function hm1m1m2(y)
      implicit none
      include 'types.f'
      include 'constants.f'
      real(dp):: y,hm1m1m2,Hm1,Hm1m10,Hm1m1m10
      external Hm1,Hm1m10,Hm1m1m10

      hm1m1m2 = Hm1(y)*Hm1m10(y) - 3*Hm1m1m10(y)
      
      return
      end
